<template>
  <div class="card history">
    <div class="flex flex-between flex-middle history_header">
      <div>
        <BSwitch
          :disabled="loading"
          :checked="wins"
          @change="(val)=>change('wins', val)"
          :activeText="$t('common.bets')"
          :inactiveText="$t('common.wins_long')"></BSwitch>
      </div>
      <div>
        <BSwitch
          :disabled="loading"
          :checked="my"
          @change="(val)=>change('my', val)"
          :activeText="$t('common.all')"
          :inactiveText="$t('common.my')"></BSwitch>
      </div>
    </div>
    <HistoryBody :loading="loading"></HistoryBody>
    <div
      class="history_footer"
      @click="showFullHistory()">
      <a>{{$t('history.fullHistory')}}</a>
      <img
        src="~/static/icons/arrowDown.png"
        alt="">
    </div>
    <transition :name="animationMenu">
      <FullHistory
        v-if="show"
        ref="fullHistory"
        @close="showFullHistory(false)"
        @closeAll="showFullHistory(false, true)"></FullHistory>
    </transition>
  </div>
</template>

<script>
  import FullHistory from '~/components/fullHistory';
  import HistoryBody from './History_body';
  import BSwitch from '~/components/UI/Switch';
  import debounce from 'lodash.debounce';


  export default {
    name: "History",
    data() {
      return {
        show: false,
        animationMenu: 'slideTo-left',
        loading: false,
        gq: () => {
        }
      }
    },
    components: {
      FullHistory,
      HistoryBody,
      BSwitch,
    },
    computed: {
      wins: {
        get() {
          return this.$store.state.game.filters.wins;
        },
        set(val) {
          this.$store.commit('game/SET_FILTER', {
            type: 'wins',
            value: val
          })
        }
      },
      my: {
        get() {
          return this.$store.state.game.filters.my;
        },
        set(val) {
          this.$store.commit('game/SET_FILTER', {
            type: 'my',
            value: val
          })
        }
      }
    },
    methods: {
      change(field, val) {
        if (field === 'wins') this.ga('wins');
        if (field === 'my') this.ga('my');
        this[field] = val;
        this.gq();
      },
      async getData() {
        this.loading = true;
        await this.$store.dispatch('game/fetchGames');
        this.loading = false;
      },
      showFullHistory(show = true, closeAll = false) {
        this.ga('fh');
        return new Promise(resolve => {
          show ? this.animationMenu = 'slideTo-left' : this.animationMenu = 'slideTo-right';
          this.$nextTick(_ => {
            this.show = show;
            if (closeAll) {
              this.$root.$refs['headerTop'].closeAll();
            }
            this.$nextTick(_ => {
              resolve();
            });
          });
        })
      }
    },
    mounted() {
      this.$root.$refs['history'] = this;
      this.gq = debounce(this.getData, 400);
    }
  }
</script>
